# 腾讯云呼叫中心外呼小程序 Demo

本文主要介绍如何快速跑通腾讯云呼叫中心 TCCC CALL DEMO(小程序)，只要按照如下步骤进行配置，就可以实现在小程序中呼叫通话功能。

## 环境要求

- 请使用企业小程序账号申请相关权限进行开发，因为小程序测试号不具备 [`<live-pusher>`](https://developers.weixin.qq.com/miniprogram/dev/component/live-pusher.html) 和 [`<live-player>`](https://developers.weixin.qq.com/miniprogram/dev/component/live-player.html) 的使用权限。
- 需要在真机上进行运行体验，因为微信开发者工具不支持原生组件 `<live-pusher>` 和 `<live-player>` 。
- 请使用原生小程序开发环境，不支持 uniapp 等开发框架。
- 微信 App iOS 最低版本要求：7.0.9
- 微信 App Android 最低版本要求：7.0.8
- 小程序基础库最低版本要求：2.10.0

## 前提条件

1. 已完成注册[微信小程序账号](https://mp.weixin.qq.com/)
2. 已完成安装[微信开发者工具](https://developers.weixin.qq.com/miniprogram/dev/devtools/download.html)
3. 已完成安装[Nodejs](https://nodejs.org/zh-cn/)
4. **确保小程序符合微信要求，并开通音视频权限。**
   - 仅支持企业类小程序
   - 仅支持[指定类目](https://developers.weixin.qq.com/miniprogram/dev/component/live-pusher.html)的小程序，具体见[微信小程序 live-push 文档](https://developers.weixin.qq.com/miniprogram/dev/component/live-pusher.html)
   - 在[微信公众平台](https://mp.weixin.qq.com/)>_开发>开发管理>接口设置_ 中开启**实时播放音视频流**、**实时录制音视频流** 两个权限。

   ![](https://qcloudimg.tencent-cloud.cn/image/document/f14449438648dada6d45848c4cf66fdf.png)

## 配置服务器域名

1. 登录[微信公众平台](https://mp.weixin.qq.com/)
2. 选择*开发>开发管理>开发设置>服务器域名*，根据下表配置

<escape> 
<table>    
  <tr>
    <th>合法域名类型</th>
    <th>域名</th>
  </tr>
  <tr>
    <td rowspan="3">request合法域名</td>
    <td>https://api.tccc.qcloud.com</td>
  </tr>
  <tr>
    <td>https://web.sdk.qcloud.com</td>
  </tr>
   <tr>
    <td>https://tccc-gavin-5g19jovqc598f12b-1258344699.ap-guangzhou.app.tcloudbase.com</td>
  </tr>
  <tr>
    <td rowspan="3">socket合法域名</td>
    <td>wss://api.tccc.qcloud.com</td>
  </tr>
</table>   
</escape>

## 配置Demo
1. 进入修改配置页，根据您下载的源码包，选择相应的开发环境。
2. 找到并打开 ./miniprogram/pages/index/debugInfo.ts 文件。
3. 设置 debugInfo.ts 文件中的相关参数：
 - Test_SecretId:默认为空字符串，请设置为实际的加密密钥ID
 - Test_SecretKey:默认为空字符串，请设置为实际的加密密钥Key
 - Test_SdkAppId：默认为0，请设置为实际的 SDKAppID。
 - Test_SeatUserId：默认为空字符串，请您需要登录的坐席邮箱。

![](https://qcloudimg.tencent-cloud.cn/raw/93742936aabd84a48e5828a1b8d7717e.png))

4. 粘贴完成后，单击已复制粘贴，下一步即可用微信开发者工具打开。
>!
>- 本文提到的生成 Token 的方案是在客户端代码中配置 SECRETKEY，该方法中 SECRETKEY 很容易被反编译逆向破解，一旦您的密钥泄露，攻击者就可以盗用您的腾讯云流量，因此该方法仅适合本地跑通 Demo 和功能调试。
>- 正确的 Token 签发方式是将 Token 的计算代码集成到您的服务端，并提供面向 App 的接口，在需要 Token 时由您的 App 向业务服务器发起请求获取动态 Token。更多详情请参见 [服务端生成 Token](https://cloud.tencent.com/document/product/679/49227)。


## 步骤4：编译运行
1. 打开微信开发者工具，选择小程序，单击新建图标，选择导入项目。
2. 填写您微信小程序的 AppID，单击导入。
3. 单击预览，生成二维码，通过手机微信扫码二维码即可进入小程序。
>!
>- 程序 <live-player> 和 <live-pusher> 标签需要在手机微信上才能使用，微信开发者工具上无法使用。
>- 为了小程序能够使用腾讯云房间管理服务，您需要在手机微信上开启调试功能：手机微信扫码二维码后，单击右上角**...** > 打开调试。

### 其他
1. [快速集成TCCC 外呼 SDK](https://www.npmjs.com/package/tccc-agent-call-wx?activeTab=readme)